diff --git a/src/backend/storage/ipc/ipci.c b/src/backend/storage/ipc/ipci.c
index 427b0d5..2a895a6 100644
--- a/src/backend/storage/ipc/ipci.c
+++ b/src/backend/storage/ipc/ipci.c
@@ -44,6 +44,7 @@
 #include "storage/procsignal.h"
 #include "storage/sinvaladt.h"
 #include "storage/spin.h"
+#include "utils/shared_meta_cache.h"
 #include "utils/snapmgr.h"
 
 /* GUCs */
@@ -147,6 +148,7 @@ CreateSharedMemoryAndSemaphores(void)
 		size = add_size(size, BTreeShmemSize());
 		size = add_size(size, SyncScanShmemSize());
 		size = add_size(size, AsyncShmemSize());
+		size = add_size(size, GlobalMetaCacheShmemSize());
 #ifdef EXEC_BACKEND
 		size = add_size(size, ShmemBackendArraySize());
 #endif
@@ -263,6 +265,7 @@ CreateSharedMemoryAndSemaphores(void)
 	BTreeShmemInit();
 	SyncScanShmemInit();
 	AsyncShmemInit();
+	GlobalMetaCacheShmemInit();
 
 #ifdef EXEC_BACKEND
 
diff --git a/src/backend/storage/lmgr/lwlock.c b/src/backend/storage/lmgr/lwlock.c
index d07ce60..008f409 100644
--- a/src/backend/storage/lmgr/lwlock.c
+++ b/src/backend/storage/lmgr/lwlock.c
@@ -87,6 +87,7 @@
 #include "storage/proclist.h"
 #include "storage/spin.h"
 #include "utils/memutils.h"
+#include "utils/shared_meta_cache.h"
 
 #ifdef LWLOCK_STATS
 #include "utils/hsearch.h"
@@ -522,6 +523,14 @@ RegisterLWLockTranches(void)
 	LWLockRegisterTranche(LWTRANCHE_PARALLEL_APPEND, "parallel_append");
 	LWLockRegisterTranche(LWTRANCHE_PARALLEL_HASH_JOIN, "parallel_hash_join");
 	LWLockRegisterTranche(LWTRANCHE_SXACT, "serializable_xact");
+	LWLockRegisterTranche(LWTRANCHE_SHARED_MCXT, "shared_mcxt");
+
+	if (IS_GLOBAL_META_CACHE)
+	{
+		LWLockRegisterTranche(LWTRANCHE_META_CACHE_MAP, "meta_cache_map");
+		LWLockRegisterTranche(LWTRANCHE_GLOBAL_CATCACHE, "global_metacache");
+		LWLockRegisterTranche(LWTRANCHE_META_CACHE_HANDLE, "meta_cache_handle");
+	}
 
 	/* Register named tranches. */
 	for (i = 0; i < NamedLWLockTrancheRequests; i++)
diff --git a/src/backend/utils/cache/Makefile b/src/backend/utils/cache/Makefile
index 38e46d2..1e430dd 100644
--- a/src/backend/utils/cache/Makefile
+++ b/src/backend/utils/cache/Makefile
@@ -23,6 +23,7 @@ OBJS = \
 	relcache.o \
 	relfilenodemap.o \
 	relmapper.o \
+	shared_cache.o \
 	spccache.o \
 	syscache.o \
 	ts_cache.o \
